/******************************************************************************/
/*          ______  ___   ______  ___   __________   ______                   */
/*          ___   |/  /   ___   |/  /   ___  ____/   __<  /                   */
/*          __  /|_/ /    __  /|_/ /    __  /_       __  /                    */
/*          _  /  / /     _  /  / /     _  __/       _  /                     */
/*          /_/  /_/      /_/  /_/      /_/          /_/                      */
/*                                                                (2010/2011) */
/******************************************************************************/
/*  Suma alternirajuceg reda racunata na tri analiticki ekvivalentna nacina.  */
/*  Napravljena usporedba sa sumom izracunatom koristeci dvostruku preciznost.*/
/*                                                                            */
/******************************************************************************/

#include<stdio.h>      // Deinirane standardne ulazno, izlazne funkcije
#include<stdlib.h>     // Deinirana nama potrebna funkcija za pauziranje
#include <math.h>      // Definirane potrebne matematicke funkcije

#define Nsum 1000000
#define fact 10

int main(void){
   float sum1, sum2, sum21, sum22, sum3;
   float element1, element21, element22, element3;
   int n, i;
   double sumd, elementd;

   FILE *output;
   output=fopen("sume.dat", "w");
   fprintf(output, "#        N              Suma_1              Suma_2");
   fprintf(output,           "              Suma_3         Suma_double\n");
   fprintf(output, "# --------    ----------------    ----------------");
   fprintf(output,           "    ----------------    ----------------\n");
   for (i=1; i<=Nsum; i*=fact){
      sum1 = sum21 = sum22 = sum3 = 0.;
      sumd = 0.;
      for (n=1; n<=i; n++){
         element21 = ( 2.*n - 1. ) / (2.*n);
         element22 = 2.*n / ( 2.*n + 1. );
         element3  = 1. / ( 2.*n * ( 2.*n + 1. ) );
         elementd  = 1. / ( 2.*n * ( 2.*n + 1. ) );
         sum21 += element21;
         sum22 += element22;
         sum3  += element3;
         sumd  += elementd;
      }
      sum2 = sum22 - sum21;
      sum1 = 0.;
      for(n=1; n<=2*i; n++){ 
         element1 = pow(-1.,n) * n / ( n+1. );           
         sum1 += element1;
      }
      fprintf(output, "%10d%20.9e%20.9e%20.9e%20.9e\n", i ,sum1 ,sum2 ,sum3, sumd);
   }
   printf("Rezultati su spremljeni u sume.dat \n");
   fclose(output);
   system("PAUSE");
}
